
//***************************************
// GY-52 ITG3205 IICԳ
// ʹõƬSTC89C51 
// 11.0592M
// ʾLCD1602
// 뻷 Keil uVision2
// ο꾧վ24c04ͨų
// ʱ䣺201191
// QQ531389319
//****************************************
#include  <REG51.H>	
#include  <math.h>    //Keil library  
#include  <stdio.h>   //Keil library	
#include  <INTRINS.H>
#define   uchar unsigned char
#define   uint unsigned int	
#define   DataPort P0    //LCD1602ݶ˿
sbit	  SCL=P1^0;      //IICʱŶ
sbit 	  SDA=P1^1;      //IICŶ
sbit      LCM_RS=P2^0;   //LCD1602˿		
sbit      LCM_RW=P2^1;   //LCD1602˿		
sbit      LCM_EN=P2^2;   //LCD1602˿ 

//ITG3205ڲַ********************
#define WHO	    0x00
#define	SMPL	0x15
#define DLPF	0x16
#define INT_C	0x17
#define INT_S	0x1A
#define	TMP_H	0x1B
#define	TMP_L	0x1C
#define	GX_H	0x1D
#define	GX_L	0x1E
#define	GY_H	0x1F
#define	GY_L	0x20
#define GZ_H	0x21
#define GZ_L	0x22
#define PWR_M	0x3E
//****************************

#define	SlaveAddress   0xD0	  //IICеĴӵַ,ALT  ADDRESSַŲͬ޸
                          
typedef unsigned char  BYTE;
typedef unsigned short WORD;

uchar dis[4];                         //ʾ
BYTE BUF[8];                         //ݻ      	         
int  dis_data;                       //
int Temperature,Temp_h,Temp_l;
void delay(unsigned int k);
void InitLcd();                     //ʼlcd1602
void InitITG3205();                 //ʼITG3205

void WriteDataLCM(uchar dataW);
void WriteCommandLCM(uchar CMD,uchar Attribc);
void DisplayOneChar(uchar X,uchar Y,uchar DData);
void DisplayListChar(uchar X,uchar Y,uchar *DData,L);

void  Single_WriteITG3205(uchar REG_Address,uchar REG_data);   //д
uchar Single_ReadITG3205(uchar REG_Address);                   //ȡڲĴ

//****************************************ģIICʹú
void Delay5us();
void ITG3205_Start();
void ITG3205_Stop();
void ITG3205_SendACK(bit ack);
bit  ITG3205_RecvACK();
void ITG3205_SendByte(BYTE dat);
BYTE ITG3205_RecvByte();
void ITG3205_ReadPage();
void ITG3205_WritePage();
//****************************************
void display_x();
void display_y();
void display_z();

//****************************************

void lcd_printf(uchar *s,int temp_data)
{
	if(temp_data<0){
	temp_data=-temp_data;
    *s='-';
	}
	else *s=' ';
    *++s =temp_data/100+0x30;
    temp_data=temp_data%100;     //ȡ
    *++s =temp_data/10+0x30;
    temp_data=temp_data%10;      //ȡ
    *++s =temp_data+0x30; 	
}

/*******************************/
void delay(unsigned int k)	
{						
unsigned int i,j;				
for(i=0;i<k;i++)
{			
for(j=0;j<121;j++)			
{;}}						
}
/*******************************/
void WaitForEnable(void)	
{					
DataPort=0xff;		
LCM_RS=0;LCM_RW=1;_nop_();
LCM_EN=1;_nop_();_nop_();
while(DataPort&0x80);	
LCM_EN=0;				
}					
/*******************************/
void WriteCommandLCM(uchar CMD,uchar Attribc)
{					
if(Attribc)WaitForEnable();	
LCM_RS=0;LCM_RW=0;_nop_();
DataPort=CMD;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}					
/*******************************/
void WriteDataLCM(uchar dataW)
{					
WaitForEnable();		
LCM_RS=1;LCM_RW=0;_nop_();
DataPort=dataW;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}		
/***********************************/
void InitLcd()				
{			
WriteCommandLCM(0x38,1);	
WriteCommandLCM(0x08,1);	
WriteCommandLCM(0x01,1);	
WriteCommandLCM(0x06,1);	
WriteCommandLCM(0x0c,1);
DisplayOneChar(0,0,'x');
DisplayOneChar(1,0,':');
DisplayOneChar(0,1,'y');
DisplayOneChar(1,1,':');
DisplayOneChar(9,0,'z');
DisplayOneChar(10,0,':');
DisplayOneChar(9,1,'T');
DisplayOneChar(10,1,':');
}			
/***********************************/
void DisplayOneChar(uchar X,uchar Y,uchar DData)
{						
Y&=1;						
X&=15;						
if(Y)X|=0x40;					
X|=0x80;			
WriteCommandLCM(X,0);		
WriteDataLCM(DData);		
}						
/***********************************/
void DisplayListChar(uchar X,uchar Y,uchar *DData,L)
{
uchar ListLength=0; 
Y&=0x1;                
X&=0xF;                
while(L--)             
{                       
DisplayOneChar(X,Y,DData[ListLength]);
ListLength++;  
X++;                        
}    
}
/**************************************
ʱ5΢(STC90C52RC@12M)
ͬĹ,Ҫ˺עʱӹʱҪ޸
1TMCUʱ,ʱ
**************************************/
void Delay5us()
{
    _nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
}

/**************************************
ʼź
**************************************/
void ITG3205_Start()
{
    SDA = 1;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 0;                    //½
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
}

/**************************************
ֹͣź
**************************************/
void ITG3205_Stop()
{
    SDA = 0;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 1;                    //
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
ڲ:ack (0:ACK 1:NAK)
**************************************/
void ITG3205_SendACK(bit ack)
{
    SDA = ack;                  //дӦź
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
**************************************/
bit ITG3205_RecvACK()
{
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    CY = SDA;                   //Ӧź
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ

    return CY;
}

/**************************************
IIC߷һֽ
**************************************/
void ITG3205_SendByte(BYTE dat)
{
    BYTE i;

    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;              //Ƴݵλ
        SDA = CY;               //ݿ
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    ITG3205_RecvACK();
}

/**************************************
IIC߽һֽ
**************************************/
BYTE ITG3205_RecvByte()
{
    BYTE i;
    BYTE dat = 0;

    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        dat |= SDA;             //               
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    return dat;
}

//ֽд*******************************************

void Single_WriteITG3205(uchar REG_Address,uchar REG_data)
{
    ITG3205_Start();                  //ʼź
    ITG3205_SendByte(SlaveAddress);   //豸ַ+дź
    ITG3205_SendByte(REG_Address);    //ڲĴַ
    ITG3205_SendByte(REG_data);       //ڲĴݣ
    ITG3205_Stop();                   //ֹͣź
}

//ֽڶȡ*****************************************
uchar Single_ReadITG3205(uchar REG_Address)
{  uchar REG_data;
    ITG3205_Start();                          //ʼź
    ITG3205_SendByte(SlaveAddress);           //豸ַ+дź
    ITG3205_SendByte(REG_Address);            //ʹ洢Ԫַ0ʼ	
    ITG3205_Start();                          //ʼź
    ITG3205_SendByte(SlaveAddress+1);         //豸ַ+ź
    REG_data=ITG3205_RecvByte();              //Ĵ
	ITG3205_SendACK(1);   
	ITG3205_Stop();                           //ֹͣź
    return REG_data; 
}

//ʼITG3205Ҫοpdf޸************************
void InitITG3205()
{
   Single_WriteITG3205(PWR_M, 0x80);   //
   Single_WriteITG3205(SMPL, 0x07);    //
   Single_WriteITG3205(DLPF, 0x1E);    //2000
   Single_WriteITG3205(INT_C, 0x00 );  //
   Single_WriteITG3205(PWR_M, 0x00);   //
}
//***********************************************************************
//ʾx
void display_x()
{  
    BUF[0]= Single_ReadITG3205(GX_L);
    BUF[1]= Single_ReadITG3205(GX_H);
    dis_data=(BUF[1]<<8)+BUF[0];   //ϳ   
    dis_data/=14.375;              //Ӧ /
    lcd_printf(dis, dis_data);     //תʾ  
    DisplayListChar(2,0,dis,4);    //ʼУУʾ飬ʾ
}

//***********************************************************************
//ʾy
void display_y()
{    
    BUF[2]= Single_ReadITG3205(GY_L);
    BUF[3]= Single_ReadITG3205(GY_H);
    dis_data=(BUF[3]<<8)+BUF[2];   //ϳ   
    dis_data/=14.375;              //Ӧ /
    lcd_printf(dis, dis_data);     //תʾ
    DisplayListChar(2,1,dis,4);    //ʼУУʾ飬ʾλ
}

//***********************************************************************
//ʾz
void display_z()
{ 
    BUF[4]= Single_ReadITG3205(GZ_L);
    BUF[5]= Single_ReadITG3205(GZ_H);
    dis_data=(BUF[5]<<8)+BUF[4];     //ϳ   
    dis_data/=14.375;                //Ӧ /
    lcd_printf(dis, dis_data);       //תʾ
    DisplayListChar(11,0,dis,4);     //ʼУУʾ飬ʾλ
}

//***********************************************************************
//ʾ¶
void display_temp()
{ 
   Temp_h=Single_ReadITG3205(TMP_H); //ȡ¶
   Temp_l=Single_ReadITG3205(TMP_L); //ȡ¶
   Temperature=Temp_h<<8|Temp_l;     //ϳ¶
   Temperature = 35+ ((double) (Temperature + 13200)) / 280; // ¶
   lcd_printf(dis,Temperature);     //תʾ
   DisplayListChar(11,1,dis,4);     //ʼУУʾ飬ʾλ
}

//*********************************************************
//**************
//*********************************************************
void main()
{ 
  delay(500);	                   //ϵʱ		
  InitLcd();                       //Һʼ
  InitITG3205();                   //ʼITG3205
  delay(50);
  while(1)                         //ѭ
  {   
    display_x();                   //---------ʾX
    display_y();                   //---------ʾY
    display_z();                   //---------ʾZ
    display_temp();                //---------ʾ¶
    delay(100);                    //ʱ            
  }
} 